#!/bin/bash

OPTIONS="hd:s:V"

DEVICE="mxcan0"
SPEED=125000

while getopts $OPTIONS OPT
do
	case $OPT in

	V ) VERBOSE=1;;
	d ) DEVICE="${OPTARG}";;
	s ) SPEED="${OPTARG}";;
	h ) echo "
 Usage: $0 [-V] [-d mxcan0] [-s 125000]
	-d - CAN device (default: mxcan0)
	-s - baud rate for device (default: 125000)
	-V - show messages for user
";exit 0;;
	esac
done

if [[ $VERBOSE ]]; then
	echo Before
	`which ifconfig` $DEVICE
	echo 
fi

if [[ $VERBOSE ]]; then
	`which ip` link set $DEVICE up type can bitrate $SPEED
else
	`which ip` link set $DEVICE up type can bitrate $SPEED 2>/dev/null
fi


if [[ $VERBOSE ]]; then
	echo
	echo After
	`which ifconfig` $DEVICE
	echo 
fi

exit 0
