#!/usr/bin/env python

import getopt
import sys
import os
import re
sys.path.insert(0, os.path.dirname(os.path.abspath(__file__)) + '/../ui/pui/')
from stp_gui.Config import Config

filename=None
outputname=None
cfgname=None

def rusage():
    print 'Usage: svg4json.py [-f inputname] [-o outputname] [-c cfgname]'


def rhelp():
    print 'Help:\n' \
          '  -h, --help\t\t\t help\n' \
          '  -c PATH, --cfg=PATH\t\t path to cfg\n' \
          '  -f PATH, --in=PATH\t\t path to input  file with SVG\n' \
          '  -o PATH, --out=PATH\t\t path to output file for JSON'


def pars_args():
    arg_list = {};
    short_opt = 'hf:o:c:'
    long_opt = 'help in= out= usage'
    try:
        optlist, arg = getopt.getopt(sys.argv[1:], short_opt, long_opt.split())
    except getopt.GetoptError, err:
        print err
        rusage()
        rhelp()
        sys.exit(0)

    global filename
    global outputname
    global cfgname

    for o, v in optlist:
        if o in ('-h', '--help'):
            rusage()
            rhelp()
            sys.exit(0)
        elif o in ('-f', '--in'):
            filename = v
        elif o in ('-o', '--out'):
            outputname = v
        elif o in ('-c', '--cfg'):
            cfgname = v
        elif o in ('-u', '--usage'):
            rv_usage()
            sys.exit(0)
        else:
            rusage()
            rhelp()
            assert False, 'unknown args'

    return arg_list

def svg4json(data):
    return re.sub('\n', '\\\\n', re.sub('"','\\"', data))

if __name__ == '__main__':
    pars_args()

    if not filename and not cfgname and not outputname:
            rusage()
            rhelp()
            sys.exit(0)

    if filename:
        try:
            data = open(filename).read()
        except (OSError, IOError), err:
            print (err)
            sys.exit(1)
    else:
        data = sys.stdin.read()
    o = None
    if outputname and not cfgname:
        o = open(outputname, 'w')
    elif not cfgname:
        o = sys.stdout
    res = svg4json(data)

    if cfgname:
        cfg = Config()
        cfg.read(cfgname)
        s = cfg.get_cfg()
        s.data['svg'] = res
        n = open(cfgname + 'svg', 'w')
        n.write(cfg.dump())
        n.close()
        print('Modify CFG save in: ' + cfgname + 'svg')

    if o:
        o.write(res)
        o.close()
