#include <dlfcn.h>
#include <fcntl.h>

#include "stp_print.h"
#include "mdev.h"
#include "dev_setup.h"
#include "stp_functions.h"
#include "algorithms.h"
#include "libmcst_dev.h"
#include "libmcst_test.h"
#include "attribute_set.h"
//#include "alginfo.h"
#include "init.h"

int main(int arc, char **argv)
{

	stp_dev_t device;
	stp_dev_t *dev = &device;

	init_stp(dev);

	usr_print_loader(dev);
	usr_main_loader(dev);

#define _UTEST_TEST_
#ifdef _UTEST_TEST_
	set_type(dev, "MEM");
#else
	set_type(dev, "ALL");
	set_algorithm(dev, "example_test");
#endif
	(*start_t)(dev);
	start_test_time(dev);

	if (library_loader(dev) < 0) {
		check_error(dev);
		check_error_system(dev);
		goto end;
	}

	if (check_dev_bitmask(dev) < 0) {
		check_error(dev);
		goto end;
	}

	if (stp_mdev_open(dev, O_RDWR) > 0) {
		if (set_attr(dev)) {
			if (set_run_alg(dev) > 0) {
				stp_mdev_close(dev);
			} else {
				p_error(dev, "Algorithm not found");
				check_error(dev);
			}
		}
	} else {
		p_error(dev, "Can not open device");
		check_error(dev);
	}


end:
	current_test_time(dev);
	stp_print_result(dev);


	if (dev->so_handler != NULL) {
		if (dlclose(dev->so_handler) != 0) {
			p_error(dev, "Error of closing shared library.");
		}
	}

	if (dev->attr.library_handler != NULL) {
		if (dlclose(dev->attr.library_handler) != 0) {
			p_error(dev, "Error of closing shared library with \'attributes\'.");
		}
	}

	return 0;

}
