#ifndef _ALGORITHMS_H_
#define _ALGORITHMS_H_

#ifdef cplusplus
extern "C" {
#endif

#include "libmcst_test.h"
#include "mdev.h"

int run_ext_test(stp_dev_t *dev);
void free_env(int count, char **env_pathes);
int check_pathes(int count, char **env_pathes);
int get_from_env(char **env_pathes);
int create_path_to_lib(stp_dev_t *dev, char *path_to_lib, char *current_dir, char *lib);
void wipe_libt(stp_lib_t *first);
int choose_run_alg(stp_dev_t *dev, stp_lib_t *lib, int string_null);
void delete_lib_t(stp_lib_t *lib);
int check_algs_for_mult(stp_dev_t *dev, stp_lib_t *lib, int count);
int checktype_for_alg(stp_dev_t *dev, const char *allowed[]);
int checkalg_for_test(char *alg);
int library_loader(stp_dev_t *dev);

#ifdef UTEST_POLL_ON
	int alg_write_poll_read(stp_dev_t *dev, const char *name);
#endif
int alg_read_write_data(stp_dev_t *dev, const char *name);
int alg_write_read_data(stp_dev_t *dev, const char *name);
int alg_duplex(stp_dev_t *dev, const char *name);
int alg_read_only(stp_dev_t *dev, const char *name);
int alg_write_only(stp_dev_t *dev, const char *name);
int alg_random_result(stp_dev_t *dev, const char *name);

void shortinfo_standard();
#ifdef UTEST_POLL_ON
  void info_standard_write_poll_read();
#endif
void info_standard_write_read();
void info_standard_duplex();
void info_standard_read_write();
void info_standard_read();
void info_standard_write();
void info_standard_random_result();

#ifdef cplusplus
}
#endif

#endif
