#ifndef _LIBMCST_DEV_H_
#define _LIBMCST_DEV_H_

#include <unistd.h>

#include "dev_structs.h"
#include <sys/mman.h>

#ifdef cplusplus
extern "C" {
#endif


#define TYPE_NOT_IMPLEMENT -4


#define GET_DEVICE_STRUCT(dev_struct, list, id, err_returned_value)	\
	if ((dev_struct = get_item_contents(list, id)) == NULL) {	\
		DBG_PRNT("error: device structure not found\n");	\
		errno = EINVAL;						\
		return err_returned_value;				\
	}

/*
 * functions
 */
int mdev_init(int dd, mattr_t *attr);
int mdev_open(char* path_to_dev, int type, int flags);
int mdev_attr_set(int dd, mattr_t *attr);
int mdev_attr_get(int dd, mattr_t *attr);
int mdev_ioctl(int dd, int flag, void *ptr);
int mdev_write(int dd, char *buf_output, int size);
int mdev_write_stop(int dd, char *buf_output, int size);
int mdev_ping(int dd);
int mdev_read(int dd, char *buf_input, int size);
int mdev_check_stop(int dd, char *buf_input, int size);
int mdev_poll(int *dd, int ndds, int timeout);
mcst_selftest_t *mdev_selftest(int dd, void *ptr);
int mdev_get_info(int dd, minfo_t *info);
int mdev_get_dev_struct(int dd, mdevice_t *dev_struct);
void *mdev_mmap(int dd, void *addr, size_t length, int prot, int flags, off_t offset);
int mdev_close(int dd);

#ifdef cplusplus
}
#endif

#endif
