#ifndef _MDEV_H_
#define _MDEV_H_

#ifdef cplusplus
extern "C" {
#endif

/** NUM is ammount of device's types
    and it declared in file init.c in func
    int init(stp_dev_t *dev) */
//#define NUM 5

#include <time.h>
#include <sys/time.h>
#include <semaphore.h>
#include <pthread.h>
#include <sched.h>
/** tst lib*/
#include "dev_structs.h"
#include "libmcst_test.h"

int algorithm_run_enable(stp_dev_t *dev, const char *user[]);
void full_string_for_output(const char *string[], char *types);
int fill_default_algorithm(stp_dev_t *dev);
void testtest(stp_dev_t *dev);
int print_cur_time(stp_dev_t *dev);
unsigned long set_mask(stp_dev_t *dev, int n_cpu);
int open_device(stp_dev_t *dev, int flags);
int set_attr(stp_dev_t *dev);
int set_realtime(stp_dev_t *dev);
void print_policy(int policy, stp_dev_t *dev);
int check(stp_dev_t *dev);
int rcheck(stp_dev_t *dev, int passes, int errors);
void check_error (stp_dev_t *dev);
#ifdef UTEST_POLL_ON
  void test_poll (stp_dev_t *dev);
#endif
void exchange_delay(stp_dev_t *dev);
void test_delay(stp_dev_t *dev);
int scheduler(stp_dev_t *dev);
int set_affinity(stp_dev_t *dev);
int set_run_alg(stp_dev_t *dev);
int check (stp_dev_t *dev);
int stp_mdev_close(stp_dev_t *dev);
void check_error_system(stp_dev_t *dev);
int run_cmd(stp_dev_t *dev, const char *cmd);

void start_alg_time(stp_dev_t *dev);
void current_alg_time(stp_dev_t *dev);
void start_test_time(stp_dev_t *dev);
void current_test_time(stp_dev_t *dev);

#ifdef cplusplus
}
#endif

#endif
