#ifndef _STP_PRINT_H_
#define _STP_PRINT_H_

#ifdef cplusplus
extern "C" {
#endif

#include "mdev.h"
#include "libmcst_test.h"

#define READ_ACTION  0
#define WRITE_ACTION 1


void print_end(stp_dev_t *dev);
void p_error(stp_dev_t *dev, const char *fmt, ...);
#define err_printf p_error
void p_warning(stp_dev_t *dev, const char *fmt, ...);
#define wrn_printf p_warning
void getdata(stp_dev_t *dev);
extern void (*start_t)(stp_dev_t *dev);
extern void (*finish_ok)(stp_dev_t *dev);
extern void (*finish_fail)(stp_dev_t *dev);
extern void (*finish_skip)(stp_dev_t *dev);
void st_start_t(stp_dev_t *dev);
void st_finish_ok(stp_dev_t *dev);
void st_finish_fail(stp_dev_t *dev);
void st_finish_skip(stp_dev_t *dev);
void prefix_postfix_loader(stp_dev_t *dev);
void get_current_time(stp_dev_t *dev);
int usr_print_loader(stp_dev_t *dev);
int usr_main_loader(stp_dev_t *dev);
void init_print(void);
void destroy_print(void);
void init_language(char *path_to_main, char *package, char *value);
extern void calculate_result(stp_dev_t *dev, int flag);
void print_test_time(stp_dev_t *dev, time_t t);
void stp_print_short_result(stp_dev_t *dev);
void stp_print_result(stp_dev_t *dev);
void dbg_printf(stp_dev_t *dev, const char *fmt, ...);
void nrm_printf(stp_dev_t *dev, const char *fmt, ...);
void vrb_printf(stp_dev_t *dev, const char *fmt, ...);
void note_printf(stp_dev_t *dev, const char *fmt, ...);
void create_logfile_resfile(stp_dev_t *dev);
int create_directory(stp_dev_t *dev, const char *name);
float measure_average_speed(stp_action_t *dev);
void utest_print_loop(stp_dev_t *dev);

#ifdef cplusplus
}
#endif

#endif
