#include <stdio.h>
#include "libmcst_test.h"
#include "stp_print.h"
#include "example.h"

static const char *work_types[] = {"ALL", NULL};


static void body_example_test(stp_dev_t *dev);
void info_example_test();

void example_test(stp_dev_t *dev)
{
	start_alg_time(dev);
	algorithm_run_enable(dev, work_types); // fill work types in device list
	//algorithm_run_disable(dev, work_types); // remove work types from device list

	while (dev->attr.number != 0 || dev->attr.test_errors != 0 || dev->attr.time != 0 ) {
		if (check(dev) == 0) {
			break;
		}
		body_example_test(dev);
		dev->pass.n++;
	}
}

static void body_example_test(stp_dev_t *dev)
{
	nrm_printf(dev, "sleep... 1 Sec");
	sleep(1);
}

/* if comment (or remove) this function
 * for final output be used standart function
 */
void print_example_test(stp_dev_t *dev)
{

	nrm_printf(dev, "test result here...");

}

void info_example_test()
{
	printf(_("example_test\n"				\
		 "\tALL\n"					\
		 "\t\texample test for demonstrate work\n"));
}
