# -*- coding: utf-8 -*-

import date_panel

from PyQt4 import QtGui, QtCore


class ExtDatePanel(QtGui.QWidget):
    def __init__(self, title='Data'):
        super(ExtDatePanel, self).__init__()

        self.box = QtGui.QGroupBox(title)

        self.date_widget = date_panel.DatePanel()
        self.date_widget.setSizePolicy(QtGui.QSizePolicy.Fixed,
                                       QtGui.QSizePolicy.Fixed)
        self.chk_bx_show_calendar = QtGui.QRadioButton('show calendar')
        self.chk_bx_show_calendar.toggled.connect(self.show_calendar_handler)
        self.calendar_widget = None

        self.box_layout = QtGui.QVBoxLayout()
        self.box_layout.addWidget(self.date_widget)
        self.box_layout.addWidget(self.chk_bx_show_calendar)
        self.box_layout.setContentsMargins(0, 0, 0, 0)

        self.box.setLayout(self.box_layout)

        main_box = QtGui.QVBoxLayout()
        main_box.addWidget(self.box)
        main_box.setContentsMargins(0, 0, 0, 0)

        self.setLayout(main_box)

    def show_calendar_handler(self, bool):
        if bool:
            self.calendar_widget = QtGui.QCalendarWidget(self)
            self.box_layout.addWidget(self.calendar_widget)
        else:
            self.box_layout.removeWidget(self.calendar_widget)
            self.calendar_widget.deleteLater()
            self.calendar_widget = None

__author__ = 'alexey'
