# -*- coding: utf-8 -*-

import sys


test_run_program = ['utest', 'tst_run', 'tst_run1']
show_mode_names = ['short', 'medium', 'full']
vk_mode_names = ['all', 'success', 'unsuccess', 'list_names', 'list_ip']
test_mode_name = ['all', 'success', 'unsuccess', 'list_names', 'list_types']

PATH_TO_RES = 'res_path'
DATA_START = 'data_start'
DATA_END = 'data_end'
SHOW_MODE = 'show_mode'
VK_MODE = 'vk_mode'
VK_LIST = 'vk_list'
RUN_PROG = 'test_run_prog'
TEST_MODE = 'test_mode'
TEST_LIST = 'test_list'

key_to_arg_opt = {PATH_TO_RES: '-r', DATA_START: '-s', DATA_END: '-e',
                  SHOW_MODE: '-m', VK_MODE: '--vk_mode', VK_LIST: '--vk_list',
                  RUN_PROG: '-p', TEST_MODE: '--test_mode',
                  TEST_LIST: '--test_list'}

DEFAULT_PATH_TO_RESULTS = '../results'

class Settings():
    def __init__(self):
        self.data = dict()

    def _dbg_wrap(fn):
        def wrap(*args):
            fn(*args)
            # DEBUG
            # print args[0].data
        return wrap

    def get_dict(self):
        return self.data

    @_dbg_wrap
    def set_path_to_res(self, path):
        self.data[PATH_TO_RES] = path

    @_dbg_wrap
    def set_all_time(self):
        if DATA_START in self.data:
            self.data.pop(DATA_START)
        if DATA_END in self.data:
            self.data.pop(DATA_END)

    @_dbg_wrap
    def set_data_start(self, day, month, year):
        self.data[DATA_START] = str(day) + '.' + str(month) + '.' + str(year)

    @_dbg_wrap
    def set_data_end(self, day, month, year):
        self.data[DATA_END] = str(day) + '.' + str(month) + '.' + str(year)

    @_dbg_wrap
    def set_show_mode(self, name):
        self.data[SHOW_MODE] = name

    @_dbg_wrap
    def set_vk_mode(self, mode):
        self.data[VK_MODE] = mode
        if VK_LIST in self.data:
            self.data.pop(VK_LIST)

    @_dbg_wrap
    def set_vk_list(self, vk_list):
        self.data[VK_LIST] = vk_list

    @_dbg_wrap
    def remove_vk_from_list(self, vk_name):
        if VK_LIST in self.data:
            self.data[VK_LIST].remove(vk_name)

    @_dbg_wrap
    def add_vk_to_list(self, vk_name):
        if VK_LIST in self.data:
            self.data[VK_LIST].append(vk_name)

    @_dbg_wrap
    def set_list_run_program(self, name_list):
        self.data[RUN_PROG] = name_list

    @_dbg_wrap
    def add_test_run_program(self, name):
        if not RUN_PROG in self.data:
            self.data[RUN_PROG] = list()
        self.data[RUN_PROG].append(name)

    @_dbg_wrap
    def remove_test_run_program(self, name):
        if RUN_PROG in self.data:
            self.data[RUN_PROG].remove(name)

    @_dbg_wrap
    def set_test_mode(self, mode):
        self.data[TEST_MODE] = mode
        if TEST_LIST in self.data:
            self.data.pop(TEST_LIST)

    @_dbg_wrap
    def set_test_list(self, test_list):
        self.data[TEST_LIST] = test_list

    @_dbg_wrap
    def remove_test_from_list(self, test_name):
        if TEST_LIST in self.data:
            self.data[TEST_LIST].remove(test_name)

    @_dbg_wrap
    def add_test_to_list(self, test_name):
        if TEST_LIST in self.data:
            self.data[TEST_LIST].append(test_name)


__author__ = 'alexey'