# -*- coding: utf-8 -*-

import subprocess
import res_settings

class ScritpWorkerExeption(Exception):
    def __init__(self, msg):
        self.msg = msg

    def __str__(self):
        return repr(self.msg)


def convert_settings_to_arg_list(settings):
    args = list()
    for key, val in settings.get_dict().items():
        args.append(res_settings.key_to_arg_opt[key])
        if type(val) == list:
            for item in val:
                args.append(item)
        else:
            args.append(val)
    return args


def get_results(settings):
    cmd = ['./new_res_viewer.py']
    cmd += convert_settings_to_arg_list(settings)
    # print cmd
    sout, serr = subprocess.Popen(cmd, stdout=subprocess.PIPE,
                                  stderr=subprocess.PIPE).communicate()
    if len(serr):
        raise ScritpWorkerExeption(serr)
        return

    if len(sout) == 0:
        return sout
    return sout.rstrip('\n').split('\n')


def get_vk_list(settings):
    cmd = ['./new_res_viewer.py', '-v']
    cmd += convert_settings_to_arg_list(settings)
    # print cmd
    sout, serr = subprocess.Popen(cmd, stdout=subprocess.PIPE,
                                  stderr=subprocess.PIPE).communicate()
    if len(serr):
        raise ScritpWorkerExeption(serr)
        return
    return map(lambda x: eval(x), filter(lambda x: len(x) > 0, sout.split('\n')))


def get_test_list(settings):
    cmd = ['./new_res_viewer.py', '-t']
    cmd += convert_settings_to_arg_list(settings)
    # print cmd
    sout, serr = subprocess.Popen(cmd, stdout=subprocess.PIPE,
                                  stderr=subprocess.PIPE).communicate()
    if len(serr):
        raise ScritpWorkerExeption(serr)
        return
    # print 'sout: {0}\nserr: {1}'.format(sout, serr)
    return map(lambda x: eval(x), filter(lambda x: len(x) > 0, sout.split('\n')))


__author__ = 'alexey'
