# -*- coding: UTF-8 -*-

"""
Code that is commonly shared
"""


import gettext
import locale
import os
import sys
import __main__


bin_dir = os.path.dirname(__main__.__file__)
#2.7 - 3.11
#stp_dir = os.path.join(bin_dir, os.path.pardir)
stp_dir = os.path.abspath(os.path.join(bin_dir, os.path.pardir))
data_dir = os.path.join(stp_dir, 'data')
doc_dir = os.path.join(stp_dir, 'doc')
locale_path = os.path.join(stp_dir, 'locale')

APP_NAME = "STP"
APP_VERSION = "Unknown"

try:
    f = open(os.path.join(data_dir, 'version'))
    APP_VERSION = f.read()
    f.close()
except IOError as e:
    print(e)

# locale directory
if os.path.exists(locale_path):
    # local locale (personal)
    locale_dir = os.path.abspath(locale_path)
else:
    # system-wide installed locale
    if sys.platform.startswith('linux'):
        locale_dir = "/usr/share/locale/"
    elif sys.platform[:6] == 'netbsd':
        locale_dir = "/usr/pkg/share/locale/"


# launcher
# launcher_path = '/usr/share/applications/stp_gui.desktop'
# if 'posix' == os.name:
#    autostart_path = os.path.expanduser(
#        '~/.config/autostart/stp_gui.desktop')


#
# gettext
#

try:
    user_locale = locale.getlocale()[0]
except:
    print('warning: error getting locale: %s' % str(sys.exc_info()[1]))
    user_locale = None

if None == user_locale:
    user_locale = 'C'
    print("warning: No default locale found.  Assuming '%s'" % user_locale)

if 'win32' == sys.platform:
    os.environ['LANG'] = user_locale

try:
    if not os.path.exists(locale_dir):
        raise RuntimeError('translations not installed')
    t = gettext.translation('stp_gui', locale_dir, [user_locale])
    _ = t.gettext
except:
    def _(msg):
        """Dummy replacement for ugettext"""
        return msg

#try:
#    ungettext = t.ungettext
#except:
#    def ungettext(singular, plural, n):
#        """Dummy replacement for Unicode, plural gettext"""
#        if 1 == n:
#            return singular
#        return plural
