# -*- coding: utf-8 -*-

from PyQt4 import QtGui, QtCore


class TextViewer (QtGui.QTextEdit):
    def __init__(self):
        super(TextViewer, self).__init__()
        self.setCurrentFont(QtGui.QFont("Courier", 12))
        self.setReadOnly(True)

    def append(self, lines):
        self.setCurrentFont(QtGui.QFont("Courier", 12))
        super(TextViewer, self).append(lines)
        cursor = self.textCursor()
        cursor.movePosition(QtGui.QTextCursor.Start)
        self.setTextCursor(cursor)

    def text_bad_request(self):
        text = 'There are no results.'
        self.setCurrentFont(QtGui.QFont("Courier", 20))
        self.setAlignment(QtCore.Qt.AlignHCenter | QtCore.Qt.AlignVCenter)
        super(TextViewer, self).append(text)

    def text_error(self, msg):
        color = self.textColor()
        self.setTextColor(QtGui.QColor('red'))
        self.append(msg)
        self.setTextColor(color)


__author__ = 'alexey'
